local dungeons = { 
	["Arcway"] = 467,
	["Azshara"] = 459,
	["Darkheart"] = 460,
	["Halls"] = 461,
	["Neltharion"] = 462,
	["Vault"] = 464,
	["Black"] = 463,
	["Maw"] = 465,
	["Court"] = 466,
	["Lower"] = 471,
	["Upper"] = 473,
	["Cath"] = 476,
}

local mLevel = 0
local dungeonID = 0
local usedEasyList = false

--Goes through bag and finds keystone
function GetKey(self, button)
	for i = 0, NUM_BAG_SLOTS do
		for j = 1, GetContainerNumSlots(i) do
			local tempItem = GetContainerItemLink(i,j)
			if tempItem ~= nil and string.match(tempItem, "Keystone") then
				ParseLink(tempItem)
			end
		end
	end
end

--Finds what roles are needed (3 DPS, 1 Healer, 1 Tank) and updates listing
function GetTitle()
	local roles = {
		HEALER = 1,
		TANK = 1,
		DAMAGER = 3,
	}
	local title = " Need"
	local playerRole = UnitGroupRolesAssigned("player")
	roles[playerRole] = roles[playerRole] - 1
	if IsInGroup() then
		local partyNum = GetNumGroupMembers()
		for i=1,partyNum-1 do
			local idk = UnitGroupRolesAssigned("party"..i)
			roles[idk] = roles[idk] - 1
		end
	end
	for k, v in pairs(roles) do
		if k == "HEALER" and v > 0 then
			title = title .. " Healer"
		end
		if k == "TANK" and v > 0 then
			title = title .. " Tank"
		end
		if k == "DAMAGER" and v > 0 then
			title = title .. " DPS"
		end
	end
	if(C_LFGList.UpdateListing(dungeonID, "+" .. mLevel .. title , 0, 0, "", "", false, false)) then
	
	end
end

--Parse Keystone link and list keystone
function ParseLink(item)
	local _, _, TmLevel = strsplit(":", item)
	usedEasyList = true
	for k, v in pairs(dungeons) do
		if 	string.match(item, k) then 
			if(C_LFGList.CreateListing(v, "+" .. TmLevel , 0, 0, "", "", false, false)) then
			dungeonID = v
			mLevel = TmLevel
			SetDungeonDifficultyID(23)
			LFGListUtil_OpenBestWindow(false);
			end
		end
	end
end

local f=CreateFrame("Button", "ELButton", GroupFinderFrame)
f:SetSize(46,46)
f:SetPoint("BOTTOMLEFT", GroupFinderFrame, 10, 10)
f:SetNormalTexture("Interface\\Icons\\INV_relics_hourglass")
f:SetHighlightTexture("Interface\\BUTTONS\\ButtonHilight-Square")
--f:SetScript("PostClick", GetKey)
f:RegisterForClicks("LeftButtonUp", "RightButtonUp")
f:SetScript("PostClick", function(self, button, down)
	if button == "LeftButton" then GetKey() end
end)
f:RegisterEvent("LFG_LIST_ACTIVE_ENTRY_UPDATE")

local g=CreateFrame("Button", nil, LFGListFrame.ApplicationViewer, "UIPanelButtonTemplate")
g:SetSize(100,22)
g:SetPoint("TOP", LFGListFrame.ApplicationViewer,  0, -85)
g:SetText("Update Listing")
g:SetFrameStrata("HIGH")
local htx = g:CreateTexture()
g:SetScript("PostClick", GetTitle)
g:Hide()

function EventHandler(self, event, ...)
	if event == "LFG_LIST_ACTIVE_ENTRY_UPDATE" then
		local isGroupListed = select(1, C_LFGList.GetActiveEntryInfo())
		if isGroupListed and usedEasyList then
			g:Show()
		end
		if not isGroupListed then
			g:Hide()
			usedEasyList = false
		end
	end
end

f:SetScript("OnEvent", EventHandler)